#include "stdafx.h"
#include "tinyxml2/tinyxml2.h"
#include "LuaCfgHelper.h"
#include <iostream>
#include <boost/algorithm/string.hpp>
#include "M_ActivityDrawLottery.h"
std::auto_ptr<M_ActivityDrawLottery> M_ActivityDrawLottery::msSingleton(nullptr);

int M_ActivityDrawLottery::GetCount()
{
	return (int)mMapData.size();
}

const M_ActivityDrawLotteryData* M_ActivityDrawLottery::GetData(int ID)
{
	auto it = mMapData.find(ID);
	if (it != mMapData.end())
	{
		return &it->second;
	}
	return NULL;
}

const std::map<int, M_ActivityDrawLotteryData>& M_ActivityDrawLottery::GetMapData()
{
	return mMapData;
}

void M_ActivityDrawLottery::Load()
{
	tinyxml2::XMLDocument xmlDoc;
	std::string content = FileUtils::getInstance()->getStringFromFile("Config/M_ActivityDrawLottery.xml");
	auto result = xmlDoc.Parse(content.c_str(), content.length());
	if (result != tinyxml2::XML_SUCCESS)
	{
		CCLOGERROR("Result:%d", result);
		CCASSERT(false, "result != tinyxml2::XML_SUCCESS");
		return;
	}
	auto root = xmlDoc.RootElement();
	if (root == NULL)
	{
		CCASSERT(false, "root == NULL");
		return;
	}
	auto element = root->FirstChildElement("Data");
	while (element != NULL)
	{
		M_ActivityDrawLotteryData data;
		data.mID = element->IntAttribute("ID");
		data.mDrawType = element->IntAttribute("DrawType");
		data.mItemId = element->IntAttribute("ItemId");
		data.mNumber = element->IntAttribute("Number");
		data.mWeight = element->IntAttribute("Weight");
		data.mDisplayLabel = element->IntAttribute("DisplayLabel");
		if (mMapData.find(data.mID) != mMapData.end())std::cout <<"data refind:" << data.mID << std::endl;
		CCASSERT(mMapData.find(data.mID) == mMapData.end(), "data.mID is exists");
		mMapData.insert(std::make_pair(data.mID, data));
		element = element->NextSiblingElement();
	}
	CCLOG("M_ActivityDrawLottery Loaded. Load Data:%u", mMapData.size());
}

void M_ActivityDrawLottery::LoadLua()
{
	LuaEngine::getInstance()->executeScriptFile("config/M_ActivityDrawLottery");
	lua_State* L = LuaEngine::getInstance()->getLuaStack()->getLuaState();
	lua_getglobal(L, "M_ActivityDrawLottery");
	CCASSERT(lua_istable(L, -1) == 1, "is not table");
	lua_pushstring(L, "datas");
	lua_gettable(L, -2);
	CCASSERT(lua_istable(L, -1) == 1, "is not table");
	lua_pushnil(L);
	while(lua_next(L, 2))
	{
		CCASSERT(lua_istable(L, -1) == 1, "is not table");
		M_ActivityDrawLotteryData data;
		LuaCfgHelper::readInt(L, "ID", data.mID);
		LuaCfgHelper::readInt(L, "DrawType", data.mDrawType);
		LuaCfgHelper::readInt(L, "ItemId", data.mItemId);
		LuaCfgHelper::readInt(L, "Number", data.mNumber);
		LuaCfgHelper::readInt(L, "Weight", data.mWeight);
		LuaCfgHelper::readInt(L, "DisplayLabel", data.mDisplayLabel);
		if (mMapData.find(data.mID) != mMapData.end())std::cout <<"data refind:" << data.mID << std::endl;
		CCASSERT(mMapData.find(data.mID) == mMapData.end(), "data.mID is exists");
		mMapData.insert(std::make_pair(data.mID, data));
		lua_pop(L, 1);
	}
	lua_settop(L, 0);
	CCLOG("M_ActivityDrawLottery Loaded. Load Data:%u", mMapData.size());
}

void M_ActivityDrawLottery::Reload()
{
	mMapData.clear();
	Load();
}

M_ActivityDrawLottery* M_ActivityDrawLottery::GetSingleton()
{
	if (msSingleton.get() == nullptr)
	{
		msSingleton.reset(new M_ActivityDrawLottery());
	}
	return msSingleton.get();
}

void M_ActivityDrawLottery::Release()
{
	msSingleton.reset(nullptr);
}
